using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Text.RegularExpressions;

using CommonLib;

namespace convertbg
{
    class Program
    {
        static void Main()
        {
            //p[^擾
            ConvParam cp = new XmlSerializer(typeof(ConvParam))
                .Deserialize(File.OpenRead(PathConf.param))
                as ConvParam;

            //~[ebNXt@C쐬
            Console.WriteLine("{0}̕ϊJn܂B", Path.GetFileName(cp.Title));
            File.WriteAllText(PathConf.mutex, Path.GetFileName(cp.Input));

            //o̓fBNgmF
            if (Directory.Exists(cp.Output) == false)
                Directory.CreateDirectory(cp.Output);

            //ĐԎ擾
            Console.WriteLine("ĐԎ擾...");
            Regex durationregex =
                new Regex(@"Duration: (?<duration>(?<hour>\d{2}):(?<min>\d{2}):(?<sec>\d{2}).(?<msec>\d))");
            string tmp = Path.GetTempFileName();
            StartWaitProcess(Path.Combine(PathConf.adir, "bat/GetDuration.bat"), cp.Input + " \"" + tmp + "\"");

            TimeSpan duration = new TimeSpan();
            string[] ss = File.ReadAllLines(Path.Combine(PathConf.tdir, "a.txt"));
            foreach (string s in ss)
            {
                if (durationregex.IsMatch(s))
                {
                    Match m = durationregex.Match(s);
                    duration = TimeSpan.Parse(m.Groups["duration"].Value);
                    File.WriteAllText(PathConf.clengthlog, m.Groups["duration"].Value);
                    break;
                }
            }
            Console.WriteLine("ĐԁF{0}", duration);

            //ԊTZ
            //int split = ((int)(1.5 * 1024)) * 8 / (cp.Ab*2 + cp.Vb);
            //Console.WriteLine("ԁF{0}b",split);

            //{
            TimeSpan start = new TimeSpan();
            for (int i = 1; start.TotalSeconds < duration.TotalSeconds-1; i++)
            {
                if (File.Exists(Path.Combine(PathConf.tdir, "tmp.3g2")))
                {
                    //ob`t@Cꎞt@C폜
                    StartWaitProcess(Path.Combine(PathConf.adir, "bat/DelTmp.bat"), "");
                }

                //ϊ
                Console.WriteLine("{1}({0}Ԗ)ϊ...\nVBF{2} ABF{3} FPSF{4}",
                    i, start, cp.Vb, cp.Ab, cp.Fps);
                StartWaitProcess(Path.Combine(PathConf.adir, "bat/Convert.bat"),
                    string.Format("\"{0}\" {1} {2} {3} {4} {5} \"{6}\" \"{7}\"",
                    cp.Input, cp.Vb, cp.Ab, cp.Fps, start.TotalSeconds, 0,
                    DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"),
                    Path.Combine(cp.Output, i.ToString("000") + ".3g2")));

                //Ԏ擾
                double sec=0.0;
                Regex timeregex = new Regex(@"time=(?<sec>\d+\.\d)");
                string[] lines = File.ReadAllLines(PathConf.commonlog);
                for (int j = lines.Length - 1; j >= 0; j--)
                {
                    if (timeregex.IsMatch(lines[j]))
                    {
                        Match m = timeregex.Match(lines[j]);
                        sec = double.Parse(m.Groups["sec"].Value);

                        break;
                    }
                }

                //ԉZ
                if (sec > 0)
                    start = start.Add(new TimeSpan((long)(sec * 10000000)));

                lines = File.ReadAllLines(PathConf.clengthlog);
                TimeSpan finished = (lines.Length == 2) ?
                    TimeSpan.Parse(lines[1]) : new TimeSpan();
                finished = finished.Add(new TimeSpan((long)(sec * 10000000)));
                File.WriteAllLines(PathConf.clengthlog,
                    new string[] { duration.ToString(), finished.ToString() });
            }

            //~[ebNXt@C폜
            File.Delete(PathConf.mutex);
        }

        private static void StartWaitProcess(string file, string arg)
        {
            Process p = new Process();
            p.StartInfo.FileName = file;
            p.StartInfo.Arguments = arg;
            p.StartInfo.CreateNoWindow = true;
            p.StartInfo.UseShellExecute = false;
            p.Start();
            p.WaitForExit();
        }
    }
}
