using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.IO;
using CommonLib;

namespace FMCGI
{
    class Program
    {
        static Encoding sjis = Encoding.GetEncoding(932);
        static Encoding enc = Encoding.UTF8;

        static void Main(string[] args)
        {
            string path;
            if (args.Length == 1)
            {
                path = decode(args[0]);
            }
            else
            {
                path = Properties.Settings.Default.ROOTDIR;
            }

            //Console.OutputEncoding = sjis;
            Console.WriteLine("Content-Type:text/html;charset=shift_jis\n");
            Console.WriteLine("<html><head><title>{0}</title></head><body><h1>{0}</h1><hr /><p>",path);
            string[] dirs = Directory.GetDirectories(path);
            foreach (string dir in dirs)
            {
                string name = Path.GetFileName(dir);
                Console.WriteLine("<a href='files.exe?{0}'><img style='border-style:none;' src='{2}/img/dir.gif' alt='[D]' />{1}</a><br />\n", encode(dir), name, PathConf.curl);
            }
            
            string[] files = Directory.GetFiles(path);
            foreach (string file in files)
            {
                string name = Path.GetFileName(file);
                Console.WriteLine("<a href='convert.exe?path={0}'><img style='border-style:none;' src='{2}/img/file.gif' alt='[F]' />{1}</a><br />\n", encode(file), name,PathConf.curl);
            }
            Console.WriteLine("</p><hr /></body></html>");
        }

        static string encode(string val)
        {
            return BitConverter.ToString(enc.GetBytes(val));
        }

        static string decode(string val)
        {
            return HttpUtility.UrlDecode("%" + val.Replace("-", "%"), enc);
        }
    }
}
